import { Component, ReactNode } from "react";
import { IForm, IFormConfig } from "../../models/Form";
import { ITypeConfig, ITypeMetaProps } from "reactive-json-schema";
export declare type ISchemaConfig = ITypeConfig;
export declare type IMetaConfig = ITypeMetaProps;
export interface IFormProps {
    schema?: ISchemaConfig;
    meta?: IMetaConfig;
    config: IFormConfig;
    snapshot?: {};
    onPatch?: (patch: {
        op: "replace" | "add" | "remove";
        path: string;
        value?: any;
    }) => void;
    onSnapshot?: (snapshot: {}) => void;
}
export interface IFormRenderProps {
    children: (form: IForm) => ReactNode;
}
export interface IFormStates {
    form: IForm;
}
export default class Form extends Component<IFormProps & IFormRenderProps, IFormStates> {
    private static getDerivedStateFromPropsFix;
    constructor(props: IFormProps & IFormRenderProps);
    componentWillReceiveProps(next: Readonly<IFormProps & IFormRenderProps>): void;
    render(): ReactNode;
}
