var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { Component } from "react";
import FormModel from "../../models/Form";
import { onPatch, onSnapshot } from "mobx-state-tree";
import { metafy, valuefy } from "reactive-json-schema";
import { deepmerge } from "../../utils";
var Form = /** @class */ (function (_super) {
    __extends(Form, _super);
    function Form(props) {
        var _this = _super.call(this, props) || this;
        _this.state = Form.getDerivedStateFromPropsFix(props);
        return _this;
    }
    Form.getDerivedStateFromPropsFix = function (props, state) {
        var pschema = props.schema, meta = props.meta, snapshot = props.snapshot;
        var config = props.config, xonPatch = props.onPatch, xonSnapshot = props.onSnapshot;
        var schema = deepmerge(__assign({}, config.schema), __assign({}, pschema));
        if (meta) {
            schema = metafy(schema, meta);
        }
        if (snapshot) {
            schema = valuefy(schema, snapshot);
        }
        var form = FormModel.create(__assign({}, config, { schema: schema }));
        if (xonSnapshot) {
            onSnapshot(form, xonSnapshot);
        }
        if (xonPatch) {
            onPatch(form, xonPatch);
        }
        return { form: form };
    };
    Form.prototype.componentWillReceiveProps = function (next) {
        var _a = this.props, config = _a.config, schema = _a.schema, meta = _a.meta, snapshot = _a.snapshot;
        if (config !== next.config ||
            schema !== next.schema ||
            meta !== next.schema ||
            snapshot !== next.snapshot) {
            this.setState(function (state) { return Form.getDerivedStateFromPropsFix(next, state); });
        }
    };
    Form.prototype.render = function () {
        var children = this.props.children;
        var form = this.state.form;
        return children(form);
    };
    return Form;
}(Component));
export default Form;
//# sourceMappingURL=Form.js.map