import * as React from "react";
import { Component, ReactNode } from "react";
import { CSSProperties, WithStyles } from "@material-ui/core/styles/withStyles";
import { ILayout } from "reactive-json-schema";
import { IForm } from "../../models/Form";
import { ISection } from "../../models/Section";
export interface IHeaderStyles {
    root: CSSProperties;
    title: CSSProperties;
    secondary: CSSProperties;
}
export interface IHeaderStyleProps extends WithStyles<keyof IHeaderStyles> {
}
export interface IHeaderProps {
    form: IForm;
    style?: CSSProperties;
    className?: string;
}
export interface IHeaderStates {
}
export declare class Header extends Component<IHeaderProps & IHeaderStyleProps, IHeaderStates> {
    render(): ReactNode;
    protected hasSectionError(section: ISection, form: IForm): boolean;
    protected hasLayoutError(layout: ILayout, form: IForm): boolean;
    protected handleChange: (event: any, selected: ISection) => void;
}
declare const _default: React.ComponentType<Pick<IHeaderProps & IHeaderStyleProps, "form" | "style" | "className"> & import("@material-ui/core/styles/withStyles").StyledComponentProps<"title" | "root" | "secondary">>;
export default _default;
