var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import * as React from "react";
import { Component } from "react";
import { observer } from "mobx-react";
import withStyles from "@material-ui/core/styles/withStyles";
import classNames from "classnames";
import Tab from "@material-ui/core/Tab";
import Tabs from "@material-ui/core/Tabs";
import Typography from "@material-ui/core/Typography";
var Header = /** @class */ (function (_super) {
    __extends(Header, _super);
    function Header() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = function (event, selected) {
            var form = _this.props.form;
            form.makeSelection(selected);
        };
        return _this;
    }
    Header.prototype.render = function () {
        var _this = this;
        var _a = this.props, clazz = _a.className, classes = _a.classes, style = _a.style;
        var form = this.props.form;
        if (!form.selected) {
            return (React.createElement(Typography, { variant: "h4", className: classes.title }, form.title));
        }
        var className = classNames(classes.root, clazz);
        var selected = form.selected;
        var hasError = this.hasSectionError(selected, form);
        return (React.createElement(Tabs, __assign({}, { className: className, style: style }, { indicatorColor: hasError ? "secondary" : "primary", textColor: hasError ? "secondary" : "primary", value: selected, onChange: this.handleChange }), form.sections.map(function (section) { return (React.createElement(Tab, { key: section.title, label: section.title, value: section, className: _this.hasSectionError(section, form) ? classes.secondary : "" })); })));
    };
    Header.prototype.hasSectionError = function (section, form) {
        return this.hasLayoutError(section.layout, form);
    };
    Header.prototype.hasLayoutError = function (layout, form) {
        var _this = this;
        return layout.some(function (item) {
            if (typeof item === "string") {
                return !form.get(item).valid;
            }
            return _this.hasLayoutError(item, form);
        });
    };
    Header = __decorate([
        observer
    ], Header);
    return Header;
}(Component));
export { Header };
export default withStyles(function (theme) { return ({
    root: {},
    secondary: {
        color: theme.palette.secondary.main
    },
    title: {}
}); })(Header);
//# sourceMappingURL=Header.js.map