import * as React from "react";
import { Component, ReactNode } from "react";
import { CSSProperties, WithStyles } from "@material-ui/core/styles/withStyles";
import { IIconRenderer } from "../Type/Renderer/Icon";
import { ITypeRenderer } from "../Type/Renderer/Type";
import { IFormProps } from "../Form";
import { IForm } from "../../models";
import { IFieldErrors } from "reactive-json-schema";
export interface IFormInlineStyles {
    root: CSSProperties;
    header: CSSProperties;
    content: CSSProperties;
    footer: CSSProperties;
    title: CSSProperties;
}
export interface IFormInlineStyleProps extends WithStyles<keyof IFormInlineStyles> {
}
export interface IFormInlineProps extends IFormProps {
    className?: string;
    style?: CSSProperties;
    children?: null;
    typer?: ITypeRenderer;
    iconer?: IIconRenderer;
    onCancel?: (form?: IForm) => void;
    onErrors?: (errors: IFieldErrors) => void;
    onSubmit: (values: {
        [key: string]: any;
    }) => void;
}
export interface IFormInlineStates {
}
export declare class FormInline extends Component<IFormInlineProps & IFormInlineStyleProps, IFormInlineStates> {
    render(): ReactNode;
}
declare const _default: React.ComponentType<Pick<IFormInlineProps & IFormInlineStyleProps, "meta" | "style" | "children" | "className" | "onSubmit" | "schema" | "onCancel" | "typer" | "iconer" | "onErrors" | "config" | "snapshot" | "onPatch" | "onSnapshot"> & import("@material-ui/core/styles/withStyles").StyledComponentProps<"content" | "footer" | "header" | "title" | "root">>;
export default _default;
