var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import * as React from "react";
import withStyles from "@material-ui/core/styles/withStyles";
import { observer } from "mobx-react";
import FormControl from "@material-ui/core/FormControl";
import FormGroup from "@material-ui/core/FormGroup";
import FormLabel from "@material-ui/core/FormLabel";
import Slider from "@material-ui/lab/Slider";
import Error from "../../Error";
import Type from "../../Type";
var Range = /** @class */ (function (_super) {
    __extends(Range, _super);
    function Range() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onChange = function (event, value) {
            _this.props.context.type.sync(value);
        };
        return _this;
    }
    Range.prototype.renderType = function (context) {
        var type = context.type;
        var classes = this.props.classes;
        var error = !type.valid ? classes.error : undefined;
        return (React.createElement(FormControl, { component: "fieldset", error: !type.valid, className: classes.stretch, disabled: type.meta.disabled, margin: "normal" },
            React.createElement(FormLabel, { component: "label", className: classes.label }, type.title + " (" + type.data + ")"),
            React.createElement(FormGroup, { className: classes.group },
                React.createElement(Slider, { disabled: type.meta.disabled, value: type.data, min: type.minimum, max: type.maximum, step: type.meta.step || type.multipleOf, onChange: this.onChange, classes: {
                        thumb: error,
                        track: error
                    } })),
            React.createElement(Error, { type: type })));
    };
    Range = __decorate([
        observer
    ], Range);
    return Range;
}(Type));
export { Range };
export default withStyles(function (theme) { return ({
    error: {
        backgroundColor: theme.palette.error.main
    },
    group: {
        marginTop: 28
    },
    label: {
        transform: "translate(0, 1.5px) scale(0.75)",
        transformOrigin: "top left"
    },
    stretch: {
        width: "100%"
    }
}); })(Range);
//# sourceMappingURL=Range.js.map