var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import * as React from "react";
import { observer } from "mobx-react";
import Layout from "react-flow-layout";
import Error from "../Error";
import Type from "../Type";
var NObject = /** @class */ (function (_super) {
    __extends(NObject, _super);
    function NObject() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NObject.prototype.renderType = function (context) {
        var type = context.type;
        var _a = context.layout, layout = _a === void 0 ? type.meta.layout : _a;
        var typer = this.props.typer;
        return (React.createElement(React.Fragment, null,
            React.createElement(Layout, { center: true, items: layout && layout.length > 0 ? layout : this.layout(type) }, function (item) {
                return typer.render(__assign({}, context, { layout: undefined, type: type.getProperty(item) }));
            }),
            React.createElement(Error, { type: type })));
    };
    NObject.prototype.layout = function (type) {
        var e_1, _a, e_2, _b;
        var properties = type.getProperties();
        var sequences = properties.map(function (property, index) {
            var sequence = type.getProperty(property).meta.sequence;
            return {
                property: property,
                sequence: sequence !== null && sequence !== undefined ? sequence : index
            };
        });
        sequences.sort(function (left, right) {
            return left.sequence === right.sequence
                ? 0
                : left.sequence > right.sequence
                    ? 1
                    : -1;
        });
        var mappings = new Map();
        try {
            for (var sequences_1 = __values(sequences), sequences_1_1 = sequences_1.next(); !sequences_1_1.done; sequences_1_1 = sequences_1.next()) {
                var _c = sequences_1_1.value, property = _c.property, sequence = _c.sequence;
                // tslint:disable-next-line:no-shadowed-variable
                var layout_1 = mappings.get(sequence);
                if (!layout_1) {
                    mappings.set(sequence, (layout_1 = []));
                }
                layout_1.push(property);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (sequences_1_1 && !sequences_1_1.done && (_a = sequences_1.return)) _a.call(sequences_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var layout = [];
        try {
            for (var _d = __values(mappings.entries()), _e = _d.next(); !_e.done; _e = _d.next()) {
                var _f = __read(_e.value, 2), sequence = _f[0], values = _f[1];
                if (values.length === 1) {
                    layout.push(values[0]);
                }
                else {
                    layout.push(values);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return layout;
    };
    NObject = __decorate([
        observer
    ], NObject);
    return NObject;
}(Type));
export default NObject;
//# sourceMappingURL=Object.js.map