var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import * as React from "react";
import { observer } from "mobx-react";
import MenuItem from "@material-ui/core/MenuItem";
import TextField from "@material-ui/core/TextField";
import Error from "../../Error";
import Type from "../../Type";
var mappings = {
    date: "date",
    datetime: "datetime-local",
    password: "password",
    select: "select",
    text: "text",
    time: "time"
};
var Text = /** @class */ (function (_super) {
    __extends(Text, _super);
    function Text() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onChange = function (event) {
            _this.props.context.type.sync(event.target.value);
        };
        return _this;
    }
    Text.prototype.renderType = function (context) {
        var type = context.type;
        var typex = mappings[type.meta.component] || "text";
        var options = type.meta.options;
        var select = typex === "select" || (!!options && options.length > 0);
        return (React.createElement(TextField, { select: select, key: type.meta.name, type: typex, margin: "normal", fullWidth: true, name: type.meta.name, id: type.meta.name, value: type.data || "", disabled: type.meta.disabled, error: !type.valid, label: type.title, helperText: Error.getError(type), onChange: this.onChange, InputLabelProps: typex.indexOf("date") === 0 ? { shrink: true } : {}, InputProps: {
                endAdornment: this.adornment("end"),
                startAdornment: this.adornment("start")
            } }, options &&
            options.map(function (option) { return (React.createElement(MenuItem, { key: option.value, value: option.value }, option.label)); })));
    };
    Text = __decorate([
        observer
    ], Text);
    return Text;
}(Type));
export default Text;
//# sourceMappingURL=Text.js.map