import { IModelType } from "mobx-state-tree";
import { IFieldErrors, ILayout, IType, ITypeConfig } from "reactive-json-schema";
import { ISection, ISectionConfig } from "../Section";
export interface IFormConfig {
    readonly title: string;
    readonly cancel?: string;
    readonly submit?: string;
    readonly schema?: ITypeConfig;
    readonly layout?: ILayout;
    readonly sections?: ISectionConfig[];
}
export interface IForm {
    readonly schema: IType;
    readonly title: string;
    readonly cancel: string;
    readonly submit: string;
    readonly modified: boolean;
    readonly valid: boolean;
    readonly validating: boolean;
    readonly fields: IType[];
    readonly errors: string[];
    readonly values: {
        [key: string]: any;
    };
    readonly layout: ILayout;
    readonly sections: ISection[];
    readonly selected: ISection | undefined;
    readonly fieldErrors: IFieldErrors;
    get(key: string): IType | undefined;
    reset(): void;
    validate(): void;
    makeSelection(section: ISection): void;
}
declare const Form: IModelType<Partial<IFormConfig>, IForm>;
export default Form;
