var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
import { types } from "mobx-state-tree";
import { createType } from "reactive-json-schema";
import { flatArray } from "../../utils";
import Section from "../Section";
var Form = types
    .model("Form", {
    cancel: types.optional(types.string, ""),
    errors: types.optional(types.array(types.string), []),
    layout: types.optional(types.frozen, []),
    schema: types.late("Schema", createType),
    sections: types.optional(types.array(Section), []),
    submit: types.optional(types.string, "Submit"),
    title: types.string
})
    .volatile(function (it) { return ({ _validating: false }); })
    .actions(function (it) { return ({
    afterCreate: function () {
        var schema = it.schema, layout = it.layout, sections = it.sections;
        var layouts = sections.map(function (section) { return section.layout; });
        var items = flatArray(__spread(layout, layouts));
        if (sections.length > 0 && !sections.some(function (section) { return section.selected; })) {
            sections[0].makeSelection(true);
        }
        var invalids = schema.type === "object"
            ? items.filter(function (item) { return !schema.properties.has(item); })
            : [];
        if (invalids.length) {
            throw new TypeError("[" + invalids
                .map(function (invalid) { return "'" + invalid + "'"; })
                .join(", ") + "] layout field" + (invalids.length === 1 ? " is" : "s are") + " not configured.");
        }
    }
}); })
    .views(function (it) { return ({
    get fields() {
        if (it.schema.type === "object") {
            return it.schema.fields;
        }
        return [it.schema];
    },
    get values() {
        var _a;
        if (it.schema.type === "object") {
            return it.schema.data;
        }
        return _a = {}, _a["" + it.schema.title] = it.schema.data, _a;
    },
    get: function (key) {
        return it.schema.getProperty
            ? it.schema.getProperty(key)
            : undefined;
    },
    get fieldErrors() {
        if (!it.schema.properties) {
            return {
                errors: it.schema.errors.slice(0)
            };
        }
        return it.schema.getFieldErrors();
    },
    get selected() {
        return it.sections.find(function (section) { return section.selected; });
    }
}); })
    .views(function (it) { return ({
    get valid() {
        return it.schema.valid;
    },
    get modified() {
        return it.schema.modified;
    },
    get validating() {
        return it._validating || it.schema.validating;
    }
}); })
    .actions(function (it) { return ({
    reset: function () {
        it.errors.length = 0;
        it.schema.reset();
    },
    makeSelection: function (selected) {
        var e_1, _a;
        try {
            for (var _b = __values(it.sections), _c = _b.next(); !_c.done; _c = _b.next()) {
                var section = _c.value;
                section.makeSelection(section === selected);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    },
    validate: function () {
        if (it.validating) {
            return [];
        }
        it._validating = true;
        it.schema.validate();
        it._validating = false;
    }
}); });
export default Form;
//# sourceMappingURL=Form.js.map