export declare const INFINITY: number;
export declare const MAX_SAFE_INTEGER: number;
export declare const MIN_SAFE_INTEGER: number;
export declare function toString(value: any): string;
export declare function toBoolean(value?: string | null): boolean;
export declare function keys(value: object): string[];
export declare function values<T = any>(object: T): T[];
export declare function isUpperCase(char: string | undefined | null): boolean;
export declare function isLowerCase(char: string | undefined | null): boolean;
export declare function isNumeric(value: any): value is number;
export declare function isNumber(value: any): value is number;
export declare function isString(value: any): value is string;
export declare function isDate(value: any): value is Date;
export declare function isArray(value: any): value is any[];
export declare function isArguments(value: any): boolean;
export declare function isUndefined(value: any): value is undefined;
export declare function isBoolean(value: any): value is boolean;
export declare function isNaN(value: any): value is typeof Number.NaN;
export declare function isNull(value: any): value is null;
export declare function toNumber(value: string, defaultn: number): number;
export declare function isObject(value: any): value is object;
export declare function isFunction(value: any): value is Function;
export declare function isLength(value: any): value is number;
export declare function isArrayLike(value: any): value is ArrayLike<any>;
export declare function isNullOrUndefined(value: any): value is null | undefined;
export declare function isEmpty(value: any): boolean;
export declare function toPromise<T>(promises: Array<Promise<T>>, resolver: (values: T[]) => T): Promise<T>;
export declare function conditional(condition: Function, fn: Function): (this: any, ...args: any[]) => any;
export declare function isNative(object: any): boolean;
export declare function replaceAll(source: string, search: string, replacement: string): string;
