import * as React from "react";
import { ReactNode } from "react";
import { CSSProperties, WithStyles } from "@material-ui/core/styles/withStyles";
import { INumber } from "reactive-json-schema";
import Type, { ITypeProps, ITypeStates } from "../../Type";
import { IRenderContext } from "../../Renderer/Type";
export interface IRangeStyles {
    group: CSSProperties;
    label: CSSProperties;
    error: CSSProperties;
    stretch: CSSProperties;
}
export interface IRangeStyleProps extends WithStyles<keyof IRangeStyles> {
}
export interface IRangeProps extends ITypeProps<INumber> {
}
export interface IRangeStates extends ITypeStates<INumber> {
}
export declare class Range extends Type<INumber, IRangeProps & IRangeStyleProps, IRangeStates> {
    protected renderType(context: IRenderContext<INumber>): ReactNode;
    private onChange;
}
declare const _default: React.ComponentType<Pick<IRangeProps & IRangeStyleProps, "context"> & import("@material-ui/core/styles/withStyles").StyledComponentProps<"error" | "label" | "group" | "stretch">>;
export default _default;
